// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'parstype.pas' rev: 3.00

#ifndef parstypeHPP
#define parstypeHPP
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Parstype
{
//-- type declarations -------------------------------------------------------
typedef Extended ParserFloat;

typedef Extended *PParserFloat;

typedef PParserFloat *PPParserFloat;

typedef Extended *ArgListArr[1];

typedef ArgListArr *PArgListArr;

typedef Extended ArgArray[1];

typedef ArgArray *PArgArray;

typedef char *PCharArr[3];

typedef PCharArr *PPCharArr;

typedef void *PtrArr[1];

typedef PtrArr *PPtrArr;

enum TSTToken { tid_NoToken, tid_InvalidToken, tid_EQ, tid_SEMICOL, tid_FOR, tid_TO, tid_DOWNTO, tid_DO, 
	tid_BEGIN, tid_END, tid_WHILE, tid_REPEAT, tid_UNTIL, tid_BREAK, tid_IF, tid_THEN, tid_ELSE, tid_EOF 
	};

enum TStatementToken { stEQ, stIfThen, stForUp, stForDown, stWhile, stRepeat, stBreak };

enum TToken { variab, constant, minus, sum, diff, prod, divis, modulo, IntDiv, integerpower, realpower, 
	square, third, fourth, lf_lt, lf_le, lf_gt, lf_ge, lf_eq, lf_neq, lf_xor, lf_or, lf_and, BldFunc, UserFunc, 
	UndefFunc };

struct TParserOperation;
typedef TParserOperation *PParserOperation;

typedef void __fastcall (*TMathProcedure)(PParserOperation AnOperation);

struct TParserOperation
{
	Extended *Arg1;
	Extended *Arg2;
	Extended *Arg3;
	ArgListArr *Args;
	int ArgCnt;
	Extended *Dest;
	TParserOperation *NextOperation;
	void *UserFO;
	System::AnsiString *UndefFuncName;
	TMathProcedure Operation;
	TToken Token;
} ;

struct TParserStatement;
typedef TParserStatement *PParserStatement;

typedef PParserStatement *PPParserStatement;

typedef void __fastcall (*TStatementProc)(PParserStatement AStatement);

struct TParserStatement
{
	TStatementToken SToken;
	Extended *STResult;
	System::TObject* ResVar;
	TParserOperation *Expr1;
	TParserOperation *Expr2;
	TParserStatement *Expr3;
	TParserStatement *Expr4;
	TStatementProc Proc;
	TParserStatement *Next;
} ;

typedef void __fastcall (__closure *TParserExceptionEvent)(System::TObject* Sender, Sysutils::Exception* 
	E);

typedef Extended __fastcall (__closure *TGetVariableEvent)(System::TObject* Sender, const System::AnsiString 
	VarName);

typedef Extended __fastcall (__closure *TGetFunctionEvent)(System::TObject* Sender, const System::AnsiString 
	FuncName, const Extended * FuncParams, const int Param_High);

typedef Extended __fastcall (__closure *TEvaluateFuncEvent)(const Extended * Params, const int Param_High
	);

typedef Classes::TStringList* __fastcall (__closure *TProvideRegFuncsEvent)(System::TObject* Sender)
	;

typedef Classes::TStringList* __fastcall (__closure *TProvideVarsListEvent)(System::TObject* Sender)
	;

typedef Classes::TComponent* __fastcall (__closure *TProvideUserLibEvent)(System::TObject* Sender);

typedef System::TObject* __fastcall (__closure *TGetHostEvent)(System::TObject* Sender);

typedef bool __fastcall (__closure *TGetUpdateEnabledEvent)(System::TObject* Sender);

class DELPHICLASS EMathParserError;
class PASCALIMPLEMENTATION EMathParserError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EMathParserError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EMathParserError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EMathParserError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EMathParserError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EMathParserError(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EMathParserError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EMathParserError(int Ident, int AHelpContext) : Sysutils::
		Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EMathParserError(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EMathParserError(void) { }
	
};

class DELPHICLASS ESyntaxError;
class PASCALIMPLEMENTATION ESyntaxError : public Parstype::EMathParserError 
{
	typedef Parstype::EMathParserError inherited;
	
public:
	/* Exception.Create */ __fastcall ESyntaxError(const System::AnsiString Msg) : Parstype::EMathParserError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall ESyntaxError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Parstype::EMathParserError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall ESyntaxError(int Ident, Extended Dummy) : Parstype::EMathParserError(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall ESyntaxError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Parstype::EMathParserError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall ESyntaxError(const System::AnsiString Msg, int AHelpContext) : 
		Parstype::EMathParserError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall ESyntaxError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Msg, Args, Args_Size, 
		AHelpContext) { }
	/* Exception.CreateResHelp */ __fastcall ESyntaxError(int Ident, int AHelpContext) : Parstype::EMathParserError(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall ESyntaxError(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Parstype::EMathParserError(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~ESyntaxError(void) { }
	
};

class DELPHICLASS EMissMatchingBracket;
class PASCALIMPLEMENTATION EMissMatchingBracket : public Parstype::EMathParserError 
{
	typedef Parstype::EMathParserError inherited;
	
public:
	/* Exception.Create */ __fastcall EMissMatchingBracket(const System::AnsiString Msg) : Parstype::EMathParserError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EMissMatchingBracket(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Parstype::EMathParserError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EMissMatchingBracket(int Ident, Extended Dummy) : Parstype::EMathParserError(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EMissMatchingBracket(int Ident, const System::TVarRec * Args
		, const int Args_Size) : Parstype::EMathParserError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EMissMatchingBracket(const System::AnsiString Msg, int AHelpContext
		) : Parstype::EMathParserError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EMissMatchingBracket(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Msg, Args, Args_Size, 
		AHelpContext) { }
	/* Exception.CreateResHelp */ __fastcall EMissMatchingBracket(int Ident, int AHelpContext) : Parstype::
		EMathParserError(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EMissMatchingBracket(int Ident, const System::TVarRec * 
		Args, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Ident, Args, Args_Size, 
		AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EMissMatchingBracket(void) { }
	
};

class DELPHICLASS EBadName;
class PASCALIMPLEMENTATION EBadName : public Parstype::EMathParserError 
{
	typedef Parstype::EMathParserError inherited;
	
public:
	/* Exception.Create */ __fastcall EBadName(const System::AnsiString Msg) : Parstype::EMathParserError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EBadName(const System::AnsiString Msg, const System::TVarRec * 
		Args, const int Args_Size) : Parstype::EMathParserError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EBadName(int Ident, Extended Dummy) : Parstype::EMathParserError(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EBadName(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Parstype::EMathParserError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EBadName(const System::AnsiString Msg, int AHelpContext) : Parstype::
		EMathParserError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EBadName(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Msg, Args, Args_Size, 
		AHelpContext) { }
	/* Exception.CreateResHelp */ __fastcall EBadName(int Ident, int AHelpContext) : Parstype::EMathParserError(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EBadName(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Parstype::EMathParserError(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EBadName(void) { }
	
};

class DELPHICLASS EFuncParamsError;
class PASCALIMPLEMENTATION EFuncParamsError : public Parstype::EMathParserError 
{
	typedef Parstype::EMathParserError inherited;
	
public:
	/* Exception.Create */ __fastcall EFuncParamsError(const System::AnsiString Msg) : Parstype::EMathParserError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EFuncParamsError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Parstype::EMathParserError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EFuncParamsError(int Ident, Extended Dummy) : Parstype::EMathParserError(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EFuncParamsError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Parstype::EMathParserError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EFuncParamsError(const System::AnsiString Msg, int AHelpContext
		) : Parstype::EMathParserError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EFuncParamsError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Msg, Args, Args_Size, 
		AHelpContext) { }
	/* Exception.CreateResHelp */ __fastcall EFuncParamsError(int Ident, int AHelpContext) : Parstype::
		EMathParserError(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EFuncParamsError(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EFuncParamsError(void) { }
	
};

class DELPHICLASS EParserInternalError;
class PASCALIMPLEMENTATION EParserInternalError : public Parstype::EMathParserError 
{
	typedef Parstype::EMathParserError inherited;
	
public:
	/* Exception.Create */ __fastcall EParserInternalError(const System::AnsiString Msg) : Parstype::EMathParserError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EParserInternalError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Parstype::EMathParserError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EParserInternalError(int Ident, Extended Dummy) : Parstype::EMathParserError(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EParserInternalError(int Ident, const System::TVarRec * Args
		, const int Args_Size) : Parstype::EMathParserError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EParserInternalError(const System::AnsiString Msg, int AHelpContext
		) : Parstype::EMathParserError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EParserInternalError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Msg, Args, Args_Size, 
		AHelpContext) { }
	/* Exception.CreateResHelp */ __fastcall EParserInternalError(int Ident, int AHelpContext) : Parstype::
		EMathParserError(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EParserInternalError(int Ident, const System::TVarRec * 
		Args, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Ident, Args, Args_Size, 
		AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EParserInternalError(void) { }
	
};

class DELPHICLASS EUnknownVariable;
class PASCALIMPLEMENTATION EUnknownVariable : public Parstype::EMathParserError 
{
	typedef Parstype::EMathParserError inherited;
	
public:
	/* Exception.Create */ __fastcall EUnknownVariable(const System::AnsiString Msg) : Parstype::EMathParserError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EUnknownVariable(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Parstype::EMathParserError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EUnknownVariable(int Ident, Extended Dummy) : Parstype::EMathParserError(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EUnknownVariable(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Parstype::EMathParserError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EUnknownVariable(const System::AnsiString Msg, int AHelpContext
		) : Parstype::EMathParserError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EUnknownVariable(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Msg, Args, Args_Size, 
		AHelpContext) { }
	/* Exception.CreateResHelp */ __fastcall EUnknownVariable(int Ident, int AHelpContext) : Parstype::
		EMathParserError(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EUnknownVariable(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EUnknownVariable(void) { }
	
};

class DELPHICLASS EUnknownFunction;
class PASCALIMPLEMENTATION EUnknownFunction : public Parstype::EMathParserError 
{
	typedef Parstype::EMathParserError inherited;
	
public:
	/* Exception.Create */ __fastcall EUnknownFunction(const System::AnsiString Msg) : Parstype::EMathParserError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EUnknownFunction(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Parstype::EMathParserError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EUnknownFunction(int Ident, Extended Dummy) : Parstype::EMathParserError(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EUnknownFunction(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Parstype::EMathParserError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EUnknownFunction(const System::AnsiString Msg, int AHelpContext
		) : Parstype::EMathParserError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EUnknownFunction(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Msg, Args, Args_Size, 
		AHelpContext) { }
	/* Exception.CreateResHelp */ __fastcall EUnknownFunction(int Ident, int AHelpContext) : Parstype::
		EMathParserError(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EUnknownFunction(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Parstype::EMathParserError(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EUnknownFunction(void) { }
	
};

class DELPHICLASS EBreakCycle;
class PASCALIMPLEMENTATION EBreakCycle : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EBreakCycle(const System::AnsiString Msg) : Sysutils::Exception(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EBreakCycle(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EBreakCycle(int Ident, Extended Dummy) : Sysutils::Exception(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EBreakCycle(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EBreakCycle(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EBreakCycle(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EBreakCycle(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EBreakCycle(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EBreakCycle(void) { }
	
};

class DELPHICLASS TLevelWidthList;
class PASCALIMPLEMENTATION TLevelWidthList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	int FLastWidth;
	
public:
	__fastcall TLevelWidthList(void);
public:
	/* TList.Destroy */ __fastcall virtual ~TLevelWidthList(void) { }
	
};

class DELPHICLASS TBracketLevelList;
class PASCALIMPLEMENTATION TBracketLevelList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	__fastcall virtual ~TBracketLevelList(void);
public:
	/* TObject.Create */ __fastcall TBracketLevelList(void) : Classes::TList() { }
	
};

class DELPHICLASS TMatrixObj;
class PASCALIMPLEMENTATION TMatrixObj : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TBracketLevelList* FLevels;
	PParserOperation __fastcall Get(int I, int J);
	void __fastcall Put(int I, int J, PParserOperation AnItem);
	int __fastcall GetBracketLevel(int I);
	void __fastcall SetBracketLevel(int I, int AWidth);
	int __fastcall GetLevelCount(void);
	int __fastcall GetWidthCount(int I);
	
public:
	__fastcall TMatrixObj(void);
	__fastcall virtual ~TMatrixObj(void);
	__property PParserOperation Matrix[int I][int J] = {read=Get, write=Put};
	__property int BracketLevel[int I] = {read=GetBracketLevel, write=SetBracketLevel};
	__property int LevelCount = {read=GetLevelCount, nodefault};
	__property int WidthCount[int I] = {read=GetWidthCount};
};

class DELPHICLASS TParserScanner;
class PASCALIMPLEMENTATION TParserScanner : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	void __fastcall GetTokenID(char * AStr, int ALen);
	System::AnsiString __fastcall GetTokenText(void);
	void __fastcall FreeTextBetween(void);
	
public:
	TSTToken TokenID;
	int TokenLen;
	char *CurrPos;
	char *LastPos;
	char *TextBetween;
	char *LastSTPos;
	char *SaveLastSTPos;
	__fastcall TParserScanner(void);
	__fastcall virtual ~TParserScanner(void);
	void __fastcall NextToken(void);
	void __fastcall MarkBeginOfStatement(void);
	void __fastcall MarkEndOfStatement(void);
	__property System::AnsiString TokenText = {read=GetTokenText};
	System::AnsiString __fastcall LastStatement(bool WithToken);
};

class DELPHICLASS TCustomUserLib;
class PASCALIMPLEMENTATION TCustomUserLib : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
public:
	/* TComponent.Create */ __fastcall virtual TCustomUserLib(Classes::TComponent* AOwner) : Classes::TComponent(
		AOwner) { }
	/* TComponent.Destroy */ __fastcall virtual ~TCustomUserLib(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::ResourceString _msgMissingBrackets;
#define Parstype_msgMissingBrackets System::LoadResourceString(&Parstype::_msgMissingBrackets)
extern PACKAGE System::ResourceString _msgParseError;
#define Parstype_msgParseError System::LoadResourceString(&Parstype::_msgParseError)
extern PACKAGE System::ResourceString _msgInternalError;
#define Parstype_msgInternalError System::LoadResourceString(&Parstype::_msgInternalError)
extern PACKAGE System::ResourceString _msgMismatchArgs;
#define Parstype_msgMismatchArgs System::LoadResourceString(&Parstype::_msgMismatchArgs)
extern PACKAGE System::ResourceString _msgReferenceError;
#define Parstype_msgReferenceError System::LoadResourceString(&Parstype::_msgReferenceError)
extern PACKAGE System::ResourceString _msgCircularReference;
#define Parstype_msgCircularReference System::LoadResourceString(&Parstype::_msgCircularReference)
extern PACKAGE System::ResourceString _msgDuplicateIdent;
#define Parstype_msgDuplicateIdent System::LoadResourceString(&Parstype::_msgDuplicateIdent)
extern PACKAGE System::ResourceString _msgInvalidIdent;
#define Parstype_msgInvalidIdent System::LoadResourceString(&Parstype::_msgInvalidIdent)
extern PACKAGE System::ResourceString _msgUnknownVar;
#define Parstype_msgUnknownVar System::LoadResourceString(&Parstype::_msgUnknownVar)
extern PACKAGE System::ResourceString _msgUnknownFunc;
#define Parstype_msgUnknownFunc System::LoadResourceString(&Parstype::_msgUnknownFunc)
extern PACKAGE System::ResourceString _msgNoSelection;
#define Parstype_msgNoSelection System::LoadResourceString(&Parstype::_msgNoSelection)
extern PACKAGE System::ResourceString _msgWrongDataSource;
#define Parstype_msgWrongDataSource System::LoadResourceString(&Parstype::_msgWrongDataSource)
extern PACKAGE System::ResourceString _msgWrongComponent;
#define Parstype_msgWrongComponent System::LoadResourceString(&Parstype::_msgWrongComponent)
extern PACKAGE System::ResourceString _msgInvalidParamTypes;
#define Parstype_msgInvalidParamTypes System::LoadResourceString(&Parstype::_msgInvalidParamTypes)
extern PACKAGE System::ResourceString _msgInvalidResultType;
#define Parstype_msgInvalidResultType System::LoadResourceString(&Parstype::_msgInvalidResultType)
extern PACKAGE System::ResourceString _msgIdentExpected;
#define Parstype_msgIdentExpected System::LoadResourceString(&Parstype::_msgIdentExpected)
extern PACKAGE System::ResourceString _msgSemiExpected;
#define Parstype_msgSemiExpected System::LoadResourceString(&Parstype::_msgSemiExpected)
extern PACKAGE System::ResourceString _msgThenExpected;
#define Parstype_msgThenExpected System::LoadResourceString(&Parstype::_msgThenExpected)
extern PACKAGE System::ResourceString _msgUnexpectedBegin;
#define Parstype_msgUnexpectedBegin System::LoadResourceString(&Parstype::_msgUnexpectedBegin)
extern PACKAGE System::ResourceString _msgBeginWOEnd;
#define Parstype_msgBeginWOEnd System::LoadResourceString(&Parstype::_msgBeginWOEnd)
extern PACKAGE System::ResourceString _msgEndWOBegin;
#define Parstype_msgEndWOBegin System::LoadResourceString(&Parstype::_msgEndWOBegin)
extern PACKAGE System::ResourceString _msgUntilNotExpected;
#define Parstype_msgUntilNotExpected System::LoadResourceString(&Parstype::_msgUntilNotExpected)
extern PACKAGE System::ResourceString _msgUntilExpected;
#define Parstype_msgUntilExpected System::LoadResourceString(&Parstype::_msgUntilExpected)
extern PACKAGE System::ResourceString _msgEQExpected;
#define Parstype_msgEQExpected System::LoadResourceString(&Parstype::_msgEQExpected)
extern PACKAGE System::ResourceString _msgTOExpected;
#define Parstype_msgTOExpected System::LoadResourceString(&Parstype::_msgTOExpected)
extern PACKAGE System::ResourceString _msgDOExpected;
#define Parstype_msgDOExpected System::LoadResourceString(&Parstype::_msgDOExpected)
extern PACKAGE System::ResourceString _msgBreakNotInCycle;
#define Parstype_msgBreakNotInCycle System::LoadResourceString(&Parstype::_msgBreakNotInCycle)
extern PACKAGE System::ResourceString _msgInvalidAssignment;
#define Parstype_msgInvalidAssignment System::LoadResourceString(&Parstype::_msgInvalidAssignment)
extern PACKAGE System::ResourceString _msgInvalidCondition;
#define Parstype_msgInvalidCondition System::LoadResourceString(&Parstype::_msgInvalidCondition)
extern PACKAGE System::ResourceString _msgInvalidForCycle;
#define Parstype_msgInvalidForCycle System::LoadResourceString(&Parstype::_msgInvalidForCycle)
extern PACKAGE System::ResourceString _msgUnexpectedToken;
#define Parstype_msgUnexpectedToken System::LoadResourceString(&Parstype::_msgUnexpectedToken)
extern PACKAGE System::ResourceString _msgUnexpectedEOF;
#define Parstype_msgUnexpectedEOF System::LoadResourceString(&Parstype::_msgUnexpectedEOF)
extern PACKAGE System::AnsiString __fastcall GenerateName(System::AnsiString APrefix, System::AnsiString 
	AName, System::AnsiString ANameType, System::TMetaClass* AClass, int Number);
extern PACKAGE System::AnsiString __fastcall CreateUniqueName(Classes::TComponent* AComp, const System::AnsiString 
	AnOldName, const System::AnsiString ANameType, System::TMetaClass* AClass, Classes::TComponent* Component
	);
extern PACKAGE bool __fastcall FindFile(System::AnsiString AFName);
extern PACKAGE char * __fastcall RemoveSpaces(char * AStr);
extern PACKAGE void __fastcall DisposeOper(PParserOperation AOper);
extern PACKAGE void __fastcall DisposeStatement(PParserStatement AStatement);
extern PACKAGE void __fastcall FreeOperationChain(PParserOperation &AnOPChain);
extern PACKAGE void __fastcall FreeStatementChain(PParserStatement &ASChain);
extern PACKAGE bool __fastcall HasReservedWord(System::AnsiString VarName);
extern PACKAGE char __fastcall UpCyr(char ACh);
extern PACKAGE System::AnsiString __fastcall UpStr(System::AnsiString AStr);
extern PACKAGE char * __fastcall StrUpperCyr(char * AStr);
extern PACKAGE bool __fastcall IsValidIdentCyr(const System::AnsiString Ident);
extern PACKAGE char * __fastcall ValidStrPos(char * AStr1, char * AStr2);
extern PACKAGE char * __fastcall RemoveChar(char * AStr, char ACh);

}	/* namespace Parstype */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Parstype;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// parstype
